/**
 * Recorder Script used in Atto sub-plugin.
 *
 * @copyright (C) 2019-2025 Yamaguchi University (gh-cc@mlex.cc.yamaguchi-u.ac.jp)
 * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define("atto_yukaltura/attorecorder",["jquery"],(function($){return{init:function(){var fileSize=0,sizeResult=!1,fileType="",uploadFileType="",naturalWidth=0,naturalHeight=0,localStream=null,videoBlob=null,videoFilename="",blobUrl=null,recorder=null,constraints=null,createObjectURL=window.URL&&window.URL.createObjectURL?function(file){return window.URL.createObjectURL(file)}:window.webkitURL&&window.webkitURL.createObjectURL?function(file){return window.webkitURL.createObjectURL(file)}:void 0,revokeObjectURL=window.URL&&window.URL.revokeObjectURL?function(file){return window.URL.revokeObjectURL(file)}:window.webkitURL&&window.webkitURL.revokeObjectURL?function(file){return window.webkitURL.revokeObjectURL(file)}:void 0,MEDIA_TYPE_VIDEO=1,AUTO_FINALIZE_NULL=-1,ENTRY_STATUS={ENTRY_IMPORTING:-2,ENTRY_CONVERTING:-1,ENTRY_IMPORT:0,ENTRY_PRECONVERT:1,ENTRY_READY:2,ENTRY_DELETED:3,ENTRY_PENDING:4,ENTRY_MODERATE:5,ENTRY_BLOCKED:6,ENTRY_NO_CONTENT:7},UPLOAD_TOKEN_STATUS_PENDING=0,UPLOAD_TOKEN_STATUS_PARTIAL_UPLOAD=1,UPLOAD_TOKEN_STATUS_FULL_UPLOAD=2;function isIE(){var ua=navigator.userAgent.toLowerCase(),ver=navigator.appVersion.toLowerCase(),isMsIE=ua.indexOf("msie")>-1&&-1==ua.indexOf("opera"),isIE6=isMsIE&&ver.indexOf("msie 6.")>-1,isIE7=isMsIE&&ver.indexOf("msie 7.")>-1,isIE8=isMsIE&&ver.indexOf("msie 8.")>-1,isIE9=isMsIE&&ver.indexOf("msie 9.")>-1,isIE10=isMsIE&&ver.indexOf("msie 10.")>-1,isIE11=ua.indexOf("trident/7")>-1;return isMsIE||isIE6||isIE7||isIE8||isIE9||isIE10||isIE11}function checkUnsupportedBrowser(){if(isIE()||(ua=navigator.userAgent.toLowerCase(),isMsEdge=ua.indexOf("edge")>-1,isChrome=ua.indexOf("chrome")>-1&&-1==ua.indexOf("edge"),isFirefox=ua.indexOf("firefox")>-1,isSafari=ua.indexOf("safari")>-1&&-1==ua.indexOf("chrome"),isOpera=ua.indexOf("opera")>-1,!0===isMsEdge&&!1===isChrome&&!1===isFirefox&&!1===isSafari&&!1===isOpera)){var browser="";return browser=isIE()?"Internet Explorer":"Edge",require(["core/str"],(function(str){var message=str.get_string("unsupported_browser","local_yumymedia",browser);$.when(message).done((function(localizedString){printInitialErrorMessage(localizedString)}))})),disableInsertButton(),enableCancelButton(),!0}var ua,isMsEdge,isChrome,isFirefox,isSafari,isOpera;return!1}function checkUnsupportedOS(){var ua,os=(ua=navigator.userAgent).match(/iPhone|iPad|iPod/)?"iOS":ua.match(/Android|android/)?"Android":ua.match(/Linux|linux/)?"Linux":ua.match(/Win(dows)/)?"Windows":ua.match(/Mac|PPC/)?"Mac OS":ua.match(/CrOS/)?"Chrome OS":"Other";return("iOS"==os||"Android"==os)&&(require(["core/str"],(function(str){var message=str.get_string("unsupported_os","local_yumymedia",os);$.when(message).done((function(localizedString){printInitialErrorMessage(localizedString)}))})),disableInsertButton(),enableCancelButton(),!0)}function printInitialErrorMessage(message){var str;str='<p><font color="red">'+message+"</font></p>",$("#upload_info").html(str),disableInsertButton(),enableCancelButton()}function startRecording(){$("#recstop").attr("src",$("#stopurl").val()),$("#recstop").off("click"),$("#recstop").on("click",(function(){!function(){if(recorder.ondataavailable=function(evt){var str;videoBlob=new Blob([evt.data],{type:evt.data.type}),blobUrl=window.URL&&window.URL.createObjectURL?window.URL.createObjectURL(videoBlob):window.webkitURL.createObjectURL(videoBlob),str=(str='<video id="webcam" width="400" height="300" ')+'src="'+blobUrl+'" autoplay="false" oncontextmenu="return false;" controls></video>',$("#videospan").html(str),document.getElementById("webcam").pause(),document.getElementById("webcam").currentTime=0,fileSize=videoBlob.size;var sizeStr="";sizeStr=fileSize>1073741824?(fileSize/1073741824).toFixed(2)+" G":fileSize>1048576?(fileSize/1048576).toFixed(2)+" M":fileSize>1024?(fileSize/1024).toFixed(2)+" k":fileSize+" ",require(["core/str"],(function(str){var message=str.get_string("video_preview","local_yumymedia",null);$.when(message).done((function(localizedString){localizedString=(localizedString='<font color="green">'+localizedString+"("+videoBlob.type+", ")+sizeStr+"B).</font>",$("#status").html(localizedString)}))})),fileType=function(fileType){if(-1!=fileType.indexOf("video/avi")||-1!=fileType.indexOf("video/x-msvideo")||-1!=fileType.indexOf("video/mpeg")||-1!=fileType.indexOf("video/mpg")||-1!=fileType.indexOf("video/mp4")||fileType.indexOf("video/ogg")||-1!=fileType.indexOf("video/quicktime")||-1!=fileType.indexOf("video/VP8")||-1!=fileType.indexOf("video/x-flv")||-1!=fileType.indexOf("video/x-f4v")||-1!=fileType.indexOf("video/x-matroska")||-1!=fileType.indexOf("video/x-ms-wmv")||-1!=fileType.indexOf("video/webm"))return"video";if(-1!=fileType.indexOf("audio/ac3")||-1!=fileType.indexOf("audio/ogg")||-1!=fileType.indexOf("audio/mpeg")||-1!=fileType.indexOf("audio/mp4")||-1!=fileType.indexOf("audio/mp3")||-1!=fileType.indexOf("audio/wav")||-1!=fileType.indexOf("audio/x-ms-wma"))return"audio";if(-1!=fileType.indexOf("image/gif")||-1!=fileType.indexOf("image/jpeg")||-1!=fileType.indexOf("image/png")||-1!=fileType.indexOf("image/tiff"))return"image";return"N/A"}(videoBlob.type),!1===(sizeResult=checkFileSize())&&(require(["core/str"],(function(str){var message=str.get_string("wrong_filesize","local_yumymedia",null);$.when(message).done((function(localizedString){window.alert(localizedString)}))})),uploadFileType=fileType,naturalWidth=0,naturalHeight=0),checkForm(),videoFilename=$("#filename").val()+"."+function(fileType){if(-1!=fileType.indexOf("video/avi")||-1!=fileType.indexOf("video/x-msvideo"))return"avi";if(-1!=fileType.indexOf("video/mpeg")||-1!=fileType.indexOf("video/mpg")||-1!=fileType.indexOf("audio/mpeg")||-1!=fileType.indexOf("audio/mpg"))return"mpeg";if(-1!=fileType.indexOf("video/mp4")||-1!=fileType.indexOf("video/m4v")||-1!=fileType.indexOf("audio/mp4"))return"mp4";if(-1!=fileType.indexOf("video/ogg"))return"ogg";if(-1!=fileType.indexOf("video/quicktime"))return"mov";if(-1!=fileType.indexOf("video/VP8")||-1!=fileType.indexOf("video/VP9")||-1!=fileType.indexOf("video/vp8")||-1!=fileType.indexOf("video/vp9")||-1!=fileType.indexOf("video/webm"))return"webm";if(-1!=fileType.indexOf("video/x-flv")||-1!=fileType.indexOf("video/x-f4v"))return"flv";if(-1!=fileType.indexOf("video/x-matroska"))return"mkv";if(-1!=fileType.indexOf("video/x-ms-wmv"))return"wmv";if(-1!=fileType.indexOf("audio/ac3"))return"ac3";if(-1!=fileType.indexOf("audio/ogg"))return"ogg";if(-1!=fileType.indexOf("audio/wav"))return"wav";if(-1!=fileType.indexOf("audio/x-ms-wma"))return"wma";if(-1!=fileType.indexOf("image/gif"))return"gif";if(-1!=fileType.indexOf("image/jpeg"))return"jpg";if(-1!=fileType.indexOf("image/png"))return"png";if(-1!=fileType.indexOf("image/tiff"))return"tiff";return"webm"}(videoBlob.type)},void 0!==localStream.getTracks&&null!==localStream.getTracks){for(var tracks=localStream.getTracks(),i=tracks.length-1;i>=0;--i)tracks[i].stop();void 0!==document.getElementById("webcam").srcObject&&(document.getElementById("webcam").srcObject=null)}recorder.stop(),$("#leftspan").css("display","none"),$("#rightspan").css("display","inline"),$("#remove").on("click",(function(){removeVideo()}))}()})),$("#leftspan").css("display","inline"),$("#webcam").volume=0,recorder.start(),require(["core/str"],(function(str){var message=str.get_string("now_recording","local_yumymedia",null);$.when(message).done((function(localizedString){$("#status").html('<font color="red">'+localizedString+"</font>")}))}))}function removeVideo(){if(-1!=window.location.protocol.indexOf("https")){if(!checkUnsupportedBrowser()&&!checkUnsupportedOS()){navigator.mediaDevices=navigator.mediaDevices||(navigator.mozGetUserMedia||navigator.webkitGetUserMedia?{getUserMedia:function(c){return function(y,n){(navigator.mozGetUserMedia||navigator.webkitGetUserMedia).call(navigator,c,y,n)}}}:null);try{if(null===navigator.mediaDevices||void 0===navigator.mediaDevices||null===MediaRecorder||void 0===MediaRecorder)return void require(["core/str"],(function(str){var message=str.get_string("disable_webrtc","local_yumymedia",null);$.when(message).done((function(localizedString){printInitialErrorMessage(localizedString)}))}));if(null==createObjectURL||null==revokeObjectURL)return void require(["core/str"],(function(str){var message=str.get_string("disable_objecturl","local_yumymedia",null);$.when(message).done((function(localizedString){printInitialErrorMessage(localizedString)}))}))}catch(err){return require(["core/str"],(function(str){var message=str.get_string("disable_webrtc","local_yumymedia",null);$.when(message).done((function(localizedString){printInitialErrorMessage(localizedString)}))})),void window.console.log(err)}var url,str;if(url=null,str='<video id="webcam" width="400" height="300" ',str+='autoplay="0" muted oncontextmenu="return false;"></video>',$("#videospan").html(str),$("#webcam").attr("src",url),null!==blobUrl&&(window.URL&&window.URL.revokeObjectURL?window.URL.revokeObjectURL(blobUrl):window.webkitURL.revokeObjectURL(blobUrl),blobUrl=null,videoBlob=null),null!==localStream)if(void 0!==localStream.getTracks||null!==localStream.getTracks){for(var tracks=localStream.getTracks(),i=tracks.length-1;i>=0;--i)tracks[i].stop();document.getElementById("webcam").srcObject&&(document.getElementById("webcam").srcObject=null)}else localStream.stop();fileSize=0,sizeResult=!1,fileType="",$("#recstop").off("click"),$("#remove").off("click"),$("#webcam").off("ondataavailable");var mimeOption="",WebcamRecorder=MediaSource||MediaRecorder;mimeOption=WebcamRecorder.isTypeSupported("video/webm")?"video/webm":WebcamRecorder.isTypeSupported("video/mp4")?"video/mp4":WebcamRecorder.isTypeSupported("video/webm;codecs=vp8,opus")?"video/webm; codecs=vp8,opus":WebcamRecorder.isTypeSupported("video/webm;codecs=vp9,opus")?"video/webm; codecs=vp9,opus":WebcamRecorder.isTypeSupported("video/webm;codecs=vp8")?"video/webm; codecs=vp8":"video/webm; codecs=vp9",constraints={audioBitsPerSecond:128e3,videoBitsPerSecond:15e5,mimeType:mimeOption,audio:{echoCancellation:!1},video:{mandatory:{minWidth:320,minHeight:240,maxWidth:1280,maxHeight:720,minFrameRate:5,maxFrameRate:15},optional:[{facingMode:"user"}]}},navigator.mediaDevices.getUserMedia(constraints).then((function(stream){localStream=stream;var video=document.getElementById("webcam");return void 0!==video.srcObject?(video.srcObject=localStream,video.play()):(blobUrl=window.URL&&window.URL.createObjectURL?window.URL.createObjectURL(blobUrl):window.webkitURL.createObjectURL(blobUrl),$("#webcam").attr("src",blobUrl)),window.console.log(localStream),recorder=null!==MediaSource||void 0!==MediaSource?new MediaRecorder(localStream):new MediaRecorder(localStream,constraints),$("#recstop").attr("src",$("#recurl").val()),$("#recstop").on("click",(function(){startRecording()})),$("#leftspan").css("display","inline"),$("#rightspan").css("display","none"),require(["core/str"],(function(str){var message=str.get_string("camera_preview","local_yumymedia",null);$.when(message).done((function(localizedString){$("#status").html(localizedString)}))})),checkForm(),0})).catch((function(err){return require(["core/str"],(function(str){var message=str.get_string("unsupported_camera","local_yumymedia",null);$.when(message).done((function(localizedString){printInitialErrorMessage(localizedString)}))})),window.console.log(err),-1}))}}else require(["core/str"],(function(str){var message=str.get_string("require_https","local_yumymedia");$.when(message).done((function(localizedString){printInitialErrorMessage(localizedString)}))}))}function checkFileSize(){var maximumDataSizeStr=$("#maximumDataSize").val(),maximumDataSize=parseInt(maximumDataSizeStr,10);return!(fileSize<=0)&&!(fileSize>maximumDataSize)}function checkForm(){null===blobUrl||null===videoBlob||0===videoBlob.size||!1===sizeResult||""===$("#name").val()||""===$("#tags").val()||""===fileType||"N/A"===fileType?($("#entry_submit").prop("disabled",!0),$("#entry").val("")):$("#entry_submit").prop("disabled",!1)}function printErrorMessage(errorMessage){$("#upload_info").html(""),$("#upload_info").append('<font color="red">'+errorMessage+"</font><br>"),disableInsertButton(),enableCancelButton()}function printSuccessMessage(id,name,tags,description,creatorId){require(["core/str","core/notification"],(function(str,notification){str.get_strings([{key:"upload_success",component:"local_yumymedia"},{key:"entryid_header",component:"local_yumymedia"},{key:"name_header",component:"local_yumymedia"},{key:"tags_header",component:"local_yumymedia"},{key:"desc_header",component:"local_yumymedia"},{key:"creatorid_header",component:"local_yumymedia"},{key:"insert_media",component:"atto_yukaltura"}]).then((function(results){var output="<h3>"+results[0]+"</h3>";return output+='<table border="2" cellpadding="5">',output+="<tr><td>"+results[1]+"</td><td>"+id+"</td></tr>",output+="<tr><td>"+results[2]+"</td><td>"+name+"</td></tr>",output+="<tr><td>"+results[3]+"</td><td>"+tags+"</td></tr>",output+="<tr><td>"+results[4]+"</td><td>"+description+"</td></tr>",output+="<tr><td>"+results[5]+"</td><td>"+creatorId+"</td></tr>",output+="</table>",output+="<br>",output+='<p><font color="red">'+results[6]+"</font></p>",$("#upload_info").html(output),0})).fail(notification.exception)})),$("#yukaltura_insert_btn",parent.document).prop("disabled",!1),$("#yukaltura_insert_btn",parent.document).css({opacity:"1.0"}),enableCancelButton()}function checkNameString(str){return!0!==/["$%&'~^\\`/]/.test(str)}function handleSubmitClick(){return!1!==(nameStr=$("#name").val(),tagsStr=$("#tags").val(),descStr=$("#description").val(),flag=!0,!1===checkNameString(nameStr)&&(require(["core/str"],(function(str){var message=str.get_string("wrong_name","local_yumymedia",null);$.when(message).done((function(localizedString){window.alert(localizedString)}))})),flag=!1),0==(!0!==/[!"#$%&'~|^\\@`()[\]{}:;+*/=<>?]/.test(tagsStr))&&(require(["core/str"],(function(str){var message=str.get_string("wrong_tags","local_yumymedia",null);$.when(message).done((function(localizedString){window.alert(localizedString)}))})),flag=!1),!1===checkNameString(descStr)&&(require(["core/str"],(function(str){var message=str.get_string("wrong_desc","local_yumymedia",null);$.when(message).done((function(localizedString){window.alert(localizedString)}))})),flag=!1),flag)&&(!1===checkFileSize()?(require(["core/str"],(function(str){var message=str.get_string("wrong_filesize","local_yumymedia",null);$.when(message).done((function(localizedString){window.alert(localizedString)}))})),!1):($("#entry_submit").prop("disabled",!0),serverHost=$("#kalturahost").val(),ks=$("#ks").val(),disableInsertButton(),$("#yukaltura_cancel_btn",parent.document).prop("disabled",!0),$("#yukaltura_cancel_btn",parent.document).css({opacity:"0.5"}),function(){if(null===parent.document.getElementById("yukaltura_select_id")||null===parent.document.getElementById("yukaltura_select_id")[0]){var element=$("body",parent.document),str='<input type="hidden" name="yukaltura_select_id" id="yukaltura_select_id" value="">';element.append(str),str='<input type="hidden" name="yukaltura_select_name" id="yukaltura_select_name" value="">',element.append(str),str=(str='<input type="hidden" name="yukaltura_host" id="yukaltura_host" value="')+$("#kalturahost").val()+'">',element.append(str),str=(str='<input type="hidden" name="yukaltura_partnerid" id="yukaltura_partnerid" value="')+$("#partnerid").val()+'">',element.append(str),str=(str='<input type="hidden" name="yukaltura_uiconfid" id="yukaltura_uiconfid" value="')+$("#uiconfid").val()+'">',element.append(str),str='<input type="hidden" name="yukaltura_width" id="yukaltura_width" value="'+$("#player_width").val()+'">',element.append(str),str='<input type="hidden" name="yukaltura_height" id="yukaltura_height" value="'+$("#player_height").val()+'">',element.append(str),str='<input type="hidden" name="yukaltura_playerstudio" id="yukaltura_playerstudio" value="'+$("#player_studio").val()+'">',element.append(str),str='<input type="hidden" name="yukaltura_filetype" id="yukaltura_filetype" value="">',element.append(str),str='<input type="hidden" name="yukaltura_naturalwidth" id="yukaltura_naturalwidth" value="">',element.append(str),str='<input type="hidden" name="yukaltura_naturalheight" id="yukaltura_naturalheight" value="">',element.append(str)}}(),function(serverHost,ks){var uploadTokenId,findData,postData={type:"GET",cache:!1,async:!0,contentType:!1,scriptCharset:"utf-8",dataType:"xml"},serviceURL=serverHost+"/api_v3/service/uploadToken/action/add?ks="+ks;serviceURL=(serviceURL=(serviceURL=(serviceURL+="&uploadToken:objectType=KalturaUploadToken")+"uploadToken:fileName="+encodeURI(videoFilename))+"&uploadToken:fileSize="+videoBlob.size)+"&uploadToken:autoFinalize="+AUTO_FINALIZE_NULL,$.ajax(serviceURL,postData).done((function(xmlData){if(null!==xmlData)if(null==(findData=$(xmlData).find("code"))||""===findData.text())if(null!=(findData=$(xmlData).find("status"))&&""!==findData.text()){var uploadTokenStatus=findData.text();uploadTokenStatus==UPLOAD_TOKEN_STATUS_PENDING?null!=(findData=$(xmlData).find("id"))&&""!==findData.text()?(uploadTokenId=findData.text(),setTimeout((function(){!function(serverHost,ks,uploadTokenId){var findData,entryStatus,entryId="",entryName="",entryTags="",entryDescription="",entryCreatorId="",nameStr=$("#name").val(),tagsStr=$("#tags").val(),descStr=$("#description").val(),controlId=$("#controlId").val(),creatorId=$("#creatorId").val();nameStr=nameStr.trim(),tagsStr=tagsStr.trim(),null!==descStr&&(descStr=descStr.trim());var fd=new FormData;fd.append("action","add"),fd.append("ks",ks),fd.append("entry:objectType","KalturaMediaEntry"),fd.append("entry:mediaType",MEDIA_TYPE_VIDEO),fd.append("entry:sourceType",1),fd.append("entry:name",nameStr),fd.append("entry:tags",tagsStr),null!==descStr&&""!==descStr?fd.append("entry:description",descStr):fd.append("entry:description",""),fd.append("entry:categories",$("#categories").val()),null!==controlId&&""!==controlId&&fd.append("entry:accessControlId",controlId),fd.append("entry:creatorId",creatorId),fd.append("entry:userId",creatorId);var postData={type:"POST",data:fd,cache:!1,async:!0,contentType:!1,scriptCharset:"utf-8",processData:!1,dataType:"xml"},serviceURL=serverHost+"/api_v3/service/media/action/add";$.ajax(serviceURL,postData).done((function(xmlData){return null==xmlData?(deleteUploadToken(serverHost,ks,uploadTokenId),void printErrorMessage("Cannot create media entry !<br>(Cannot get a XML response.)")):null!=(findData=$(xmlData).find("code"))&&""!==findData.text()?(deleteUploadToken(serverHost,ks,uploadTokenId),void printErrorMessage("Cannot create media entry !<br>("+findData.text()+")")):null==(findData=$(xmlData).find("status"))||""===findData.text()?(deleteUploadToken(serverHost,ks,uploadTokenId),void printErrorMessage("Cannot create media entyry !<br>(Cannot get a mediaEntryStatus.)")):(entryStatus=findData.text())!=ENTRY_STATUS.ENTRY_NO_CONTENT?(deleteUploadToken(serverHost,ks,uploadTokenId),void printErrorMessage("Cannot create media entry!<br>(mediaEntryStatus: "+entryStatus+")")):(findData=$(xmlData).find("id"),entryId=findData.text(),findData=$(xmlData).find("name"),entryName=findData.text(),findData=$(xmlData).find("tags"),entryTags=findData.text(),findData=$(xmlData).find("description"),entryDescription=null!=findData&&""!==findData.text()?findData.text():"",findData=$(xmlData).find("creatorId"),entryCreatorId=findData.text(),null===entryId||""===entryId||null===entryName||""===entryName||null===entryTags||""===entryTags||null===entryCreatorId||""===entryCreatorId||""!==descStr&&(null===entryDescription||""===entryDescription)?(deleteUploadToken(serverHost,ks,uploadTokenId),void printErrorMessage("There exists wrong information(s) <br>")):void setTimeout((function(){!function(serverHost,ks,uploadTokenId,entryId){var findData,fd=new FormData;$("#upload_info").html(""),require(["core/str"],(function(str){var message=str.get_string("recorder_uploading","local_yumymedia",null);$.when(message).done((function(localizedString){$("#upload_info").append(localizedString+"<br>")}))})),require(["core/str"],(function(str){var message=str.get_string("progress","local_yumymedia",null);$.when(message).done((function(localizedString){var str="<p>"+localizedString;str+=': <span id="pvalue" style="color:#00b200">0.00</span> %</p>',$("#upload_info").append(str)}))})),fd.append("action","upload"),fd.append("ks",ks),fd.append("uploadTokenId",uploadTokenId),fd.append("fileData",videoBlob,encodeURI(videoFilename),videoBlob.size),fd.append("resume",!1),fd.append("finalChunk",!0),fd.append("resumeAt",0);var postData={type:"POST",data:fd,cache:!1,async:!0,contentType:!1,scriptCharset:"utf-8",processData:!1,dataType:"xml",xhr:function(){var XHR=$.ajaxSettings.xhr();return XHR.upload&&XHR.upload.addEventListener("progress",(function(e){var newValue=parseInt(e.loaded/e.total*100);$("#pvalue").html(parseInt(newValue))}),!1),XHR}},serviceURL=serverHost+"/api_v3/service/uploadToken/action/upload";$.ajax(serviceURL,postData).done((function(xmlData){if(null===xmlData)return deleteUploadToken(serverHost,ks,uploadTokenId),void printErrorMessage("Cannot upload the video !<br>(Cannot get a XML response.)");if(null!=(findData=$(xmlData).find("code"))&&""!==findData.text())return deleteUploadToken(serverHost,ks,uploadTokenId),void printErrorMessage("Cannot upload the video !<br>("+findData.text()+")");if(null==(findData=$(xmlData).find("status"))||""===findData.text())return deleteUploadToken(serverHost,ks,uploadTokenId),void printErrorMessage("Cannot upload the video !<br>(Cannot get an uploadTokenStatus.)");var uploadTokenStatus=findData.text();if(uploadTokenStatus!=UPLOAD_TOKEN_STATUS_FULL_UPLOAD&&uploadTokenStatus!=UPLOAD_TOKEN_STATUS_PARTIAL_UPLOAD)return deleteUploadToken(serverHost,ks,uploadTokenId),void printErrorMessage("Cannot upload the video !<br>(UPLOAD_TOKEN_STATUS : "+uploadTokenStatus+")");window.console.log("File chunk have been transmitted."),require(["core/str"],(function(str){var message=str.get_string("attach_file","local_yumymedia",null);$.when(message).done((function(localizedString){$("#upload_info").append(localizedString+"<br>")}))})),setTimeout((function(){!function(serverHost,ks,uploadTokenId,entryId){var entryStatus,findData,entryName="",entryTags="",entryDescription="",entryCreatorId="",fd=new FormData;fd.append("action","addContent"),fd.append("ks",ks),fd.append("entryId",entryId),fd.append("resource:objectType","KalturaUploadedFileTokenResource"),fd.append("resource:token",uploadTokenId);var postData={type:"POST",data:fd,cache:!1,async:!0,contentType:!1,scriptCharset:"utf-8",processData:!1,dataType:"xml"},serviceURL=serverHost+"/api_v3/service/media/action/addContent";$.ajax(serviceURL,postData).done((function(xmlData){return null==xmlData?(deleteUploadToken(serverHost,ks,uploadTokenId),void printErrorMessage("Cannot attach uploaded file !<br>(Cannot get a XML response.)")):null!=(findData=$(xmlData).find("code"))&&""!==findData.text()?(deleteUploadToken(serverHost,ks,uploadTokenId),void printErrorMessage("Cannot attach uploaded file !<br>("+findData.text()+")")):null==(findData=$(xmlData).find("status"))||""===findData.text()?(deleteUploadToken(serverHost,ks,uploadTokenId),void printErrorMessage("Cannot attach uploaded file !<br>(Cannot get a mediaEntryStatus.)")):(entryStatus=findData.text())!=ENTRY_STATUS.ENTRY_READY&&entryStatus!=ENTRY_STATUS.ENTRY_PENDING&&entryStatus!=ENTRY_STATUS.ENTRY_PRECONVERT&&entryStatus!=ENTRY_STATUS.IMPORT&&entryStatus!=ENTRY_STATUS.IMPORTING?(deleteUploadToken(serverHost,ks,uploadTokenId),void printErrorMessage("Cannot attach uploaded file !<br>(mediaEntryStatus: "+entryStatus+")")):(findData=$(xmlData).find("id"),entryId=findData.text(),findData=$(xmlData).find("name"),entryName=findData.text(),findData=$(xmlData).find("tags"),entryTags=findData.text(),findData=$(xmlData).find("description"),entryDescription=null!=findData&&""!==findData.text()?findData.text():"",findData=$(xmlData).find("creatorId"),entryCreatorId=findData.text(),printSuccessMessage(entryId,entryName,entryTags,entryDescription,entryCreatorId),name=entryName,void(null!==(id=entryId)&&""!==id&&null!==parent.document.getElementById("yukaltura_select_id")&&null!==parent.document.getElementById("yukaltura_select_id")[0]&&($("#yukaltura_select_id",parent.document).val(id),$("#yukaltura_select_name",parent.document).val(name),$("#yukaltura_filetype",parent.document).val(uploadFileType),$("#yukaltura_naturalwidth",parent.document).val(naturalWidth),$("#yukaltura_naturalheight",parent.document).val(naturalHeight))));var id,name})).fail((function(xmlData){null!==xmlData&&window.console.dir(xmlData),deleteUploadToken(serverHost,ks,uploadTokenId),printErrorMessage("Cannot attach uploaded file !<br>(Cannot connect to kaltura server.)")}))}(serverHost,ks,uploadTokenId,entryId)}),1e3)})).fail((function(xmlData){null!==xmlData&&window.console.dir(xmlData),deleteUploadToken(serverHost,ks,uploadTokenId),printErrorMessage("Cannot upload the file !<br>(Cannot connect to contents server.)")}))}(serverHost,ks,uploadTokenId,entryId)}),50))})).fail((function(xmlData){null!==xmlData&&window.console.dir(xmlData),deleteUploadToken(serverHost,ks,uploadTokenId),printErrorMessage("Cannot create media entry !<br>(Cannot connect to kaltura server.)")}))}(serverHost,ks,uploadTokenId)}),50)):printErrorMessage("Cannot create uplaod token !<br>(Cannot get an uploadTokenId.)"):printErrorMessage("Cannot create upload token !<br>(UPLOAD_TOKEN_STATUS : "+uploadTokenStatus+")")}else printErrorMessage("Cannot create upload token !<br>(Cannot get status of upload token.)");else printErrorMessage("Cannot create upload token !<br>("+findData.text()+")");else printErrorMessage("Cannot create upload token !<br>(Cannot get a XML response.)")})).fail((function(xmlData){null!==xmlData&&window.console.dir(xmlData),printErrorMessage("Cannot create upload token !<br>(Cannot connect to kaltura server.)")}))}(serverHost,ks),!0));var nameStr,tagsStr,descStr,flag,serverHost,ks}function disableInsertButton(){$("#yukaltura_insert_btn",parent.document).prop("disabled",!0),$("#yukaltura_insert_btn",parent.document).css({opacity:"0.5"})}function enableCancelButton(){$("#yukaltura_cancel_btn",parent.document).prop("disabled",!1),$("#yukaltura_cancel_btn",parent.document).css({opacity:"1.0"})}function deleteUploadToken(serverHost,ks,uploadTokenId){var flag,fd=new FormData;fd.append("action","delete"),fd.append("ks",ks),fd.append("uploadTokenId",uploadTokenId);var postData={type:"POST",data:fd,cache:!1,contentType:!1,scriptCharset:"utf-8",processData:!1,async:!0,dataType:"xml"},serviceURL=serverHost+"/api_v3/service/uploadToken/action/delete";return $.ajax(serviceURL,postData).done((function(xmlData){null===xmlData&&(flag=!1),flag=!0})).fail((function(xmlData){flag=!1,null!==xmlData&&window.console.dir(xmlData)})),flag}$(window).on("change",(function(){checkForm()})),$(window).on("load",(function(){$("#name").val(""),$("#tags").val(""),$("#description").val("")})),removeVideo(),$(window).on("unload",(function(){if(null!==blobUrl&&(window.URL&&window.URL.revokeObjectURL?window.URL.revokeObjectURL(blobUrl):window.webkitURL.revokeObjectURL(blobUrl),videoBlob=null,blobUrl=null),null!==localStream){if(localStream.getTracks)for(var tracks=localStream.getTracks(),i=tracks.length-1;i>=0;--i)tracks[i].stop();else localStream.stop();document.getElementById("webcam").srcObject&&(document.getElementById("webcam").srcObject=null)}var serviceURL;serviceURL=$("#kalturahost").val()+"/api_v3/service/session/action/end",$.ajax({type:"GET",url:serviceURL,cache:!1}).done((function(xmlData){null===xmlData?window.console.log("Cannot delete the uploadToken ! (Cannot get a XML response.)"):window.console.log("Kaltura Session has been deleted.")})).fail((function(xmlData){window.console.log("Cannot delete the uploadToken ! (Cannot connect to kaltura server.)"),null!==xmlData&&window.console.dir(xmlData)}))})),$("#name").on("change",(function(){checkForm()})),$("#tags").on("change",(function(){checkForm()})),$("#entry_submit").on("click",(function(){handleSubmitClick()})),$("#entry_reset").on("click",(function(){$("#file_info").html(""),$("#type").val(""),uploadFileType="",naturalWidth=0,naturalHeight=0,disableInsertButton(),enableCancelButton()})),$("#yukaltura_select_id",parent.document).remove(),$("#yukaltura_select_name",parent.document).remove(),$("#yukaltura_host",parent.document).remove(),$("#yukaltura_partnerid",parent.document).remove(),$("#yukaltura_uiconfid",parent.document).remove(),$("#yukaltura_playerstudio",parent.document).remove(),$("#yukaltura_width",parent.document).remove(),$("#yukaltura_height",parent.document).remove(),$("#yukaltura_filetype",parent.document).remove(),$("#yukaltura_naturalwidth",parent.document).remove(),$("#yukaltura_naturalheight",parent.document).remove(),disableInsertButton(),enableCancelButton()}}}));

//# sourceMappingURL=attorecorder.min.js.map